Subject: bug#78503: 30.0.92; tree-sitter elixir-ts-mode structural movement broken

From: Wilhelm Kirschbaum <[email-masked]>
Date: Mon, 26 May 2025 08:52:02 +0200

On Fri, May 23, 2025 at 8:28 PM Juri Linkov <[email-masked]> wrote:

> > Hi, sorry for the delay.
> >
> > I had a look at the latest changes and it makes sense to me. Thanks again
> > Juri :).
>
> This was only the second part.  But what do you think about the
> first part about removing `defmodule` from 'C-M-a' defun navigation:
>
>   1.) `defmodule` is considered a function definition and so moving up
> from the first
>   actual function definition `def my_fun do` causes the point to jump to
>   'defmodule my_mod do'. Invoking `end-of-defun` jumps to the end of the
> defmodule block.
>   Effectively, you have been ejected from the module body.
>
>   ;; current scoped workaround
>   ;; does not jump up to defmodule when using `beginning-of-defun`
>   (defun elixir-ts--defun-p (node)
>     "Return non-nil when NODE is a defun."
>     (member (treesit-node-text
>              (treesit-node-child-by-field-name node "target"))
>             (append
>              (remove "defmodule" elixir-ts--definition-keywords)
>              elixir-ts--test-definition-keywords)))
>

It is not ideal to be ejected from the module body and was not the initial
desired behaviour. modules can be nested and there can be multiple in a
single file, so not being able to navigate with C-M-a is less ideal imo. I
remember trying to solve this issue in the early days of treesit.el, but it
became too complex, perhaps there is an easier way now?